 $LIB COM -, LPT -, GRAPH -, FULLFLOAT -, IPRINT -
 $CPU 8086
 $stack 8192
 $string 1
 'meine (!) Definition der Registernamenkonstanten
 %FL    = 0
 %AX    = 1
 %BX    = 2
 %CX    = 3
 %DX    = 4
 %SI    = 5
 %DI    = 6
 %BP    = 7
 %DS    = 8
 %ES    = 9
 '
 def seg = 0 :'PEEK/POKE usw. ohne Segment:Offset-Trennung mglich
 '
 'Konvertiert eine beliebige Diskette oder hnliches
 'in ein EPROM-File fr Portfolio-EPROM-Karte mit 64-1024KByte
 'Medium mu 512 Byte pro Sektor, 12Bit-FAT-Eintrge und einen normalen
 'Bootsektor haben, in dem wie bei Disks die Greninformationen stehen
 '(C) SWB 1992
 'portiert von Omikron.Basic nach Power Basic
 'letzte nderung in Power Basic vom 08.01.1993
 'Achtung: &hxxx sind immer 16Bit-Integer!!!
 '
 if fre(-1) < (65536+32768) then
  print "Speicher reicht nicht. Ende mit [Leertaste]"
  a%=FNTastwahl%(" ")
  end
 end if
 'Speicher kann nur im Basic-Bereich reserviert werden, aber geschtzt
 speicher& = endmem - (65536+64):'64 zur Sicherheit
 memset speicher&
 speicher&=(speicher&+32) and 2147483632& :'=$7FFFFFF0 also auf Segmentgrenze
 '64KByte habe ich nun fr mich
 '
 DIM Ename$(5),Ekapa&(5),Esymb$(5),Esect&(5)
 RESTORE Epromdaten
 FOR F%=1 TO 5
  READ Ename$(F%),Ekapa&(F%),Esymb$(F%),Esect&(F%)
 NEXT F%
 '
 BytesSector&=512:'wichtige Konstante
 '
 PRINT " ******************************************************************"
 PRINT " *  DISK zu EPROM Konverter           (C) SWB 1992  (06.09.1992)  *"
 PRINT " ******************************************************************"
 PRINT
 PRINT " von Harun Scheutzow, Berlin, fr tri tec"
 PRINT " Programmiert in Power Basic"
 PRINT
 PRINT " Dieses Programm konvertiert eine Diskette in ein EPROM-File fr"
 PRINT " die Portfolio-EPROM-Karte."
 PRINT
 PRINT
 do:'REPEAT
  PRINT " Von welchem Laufwerk sollen die zu konvertierenden Daten kommen?"
  PRINT " Bitte die entsprechende Buchstabentaste drcken."
  PRINT "  Laufwerk: ";
  Sourcedrv%=FNTastwahl%("ABCDEFGHIJKLMNOPQRSTUVWXYZ")-1
  PRINT CHR$(Sourcedrv%+&h41)
  PRINT
  PRINT " Geben sie nun den Pfad und Namen der zu erstellenden EPROM-Datei ein"
  INPUT "  EPROM-Datei: ";Epromdat$
  PRINT
  RESTORE Epromdaten
  A$=""
  PRINT " Fr welche EPROM-Gre soll die Datei erstellt werden?"
  FOR F%=1 TO 5
   PRINT " [";Esymb$(F%);"] ->  ";
   print using "#####";Ekapa&(F%);
   print "KByte, ";Ename$(F%)
   A$=A$+Esymb$(F%)
  NEXT F%
  PRINT "  EPROM-Typ:";
  Epromtyp%=FNTastwahl%(A$)
  PRINT Ekapa&(Epromtyp%);"KByte, ";Ename$(Epromtyp%)
  PRINT
  PRINT " Folgende Werte wurden eingestellt:"
  PRINT " Daten von Laufwerk "; CHR$(Sourcedrv%+&h41)
  IF Sourcedrv%>1 THEN
   PRINT "  Sind sie sicher, das Laufwerk "; CHR$(Sourcedrv%+&h41);" das gleiche Format wie"
   PRINT "  eine Diskette besitzt?"
  END IF
  PRINT " EPROM-Datei nach ";Epromdat$
  PRINT " EPROM-Gre ";
  print using "#####";Ekapa&(Epromtyp%);
  print "KByte, ";Ename$(Epromtyp%)
  PRINT
  PRINT " [K]onvertierung starten"
  PRINT " [E]ingabe wiederholen"
  PRINT " [V]erlassen, Programm sofort beenden"
  PRINT "  Auswahl:"
  A%=FNTastwahl%("KEV")
  PRINT
 loop until A%<>2
 PRINT
 IF A%=1 THEN
  PRINT " Konvertierung startet"
  'Fsfirst auf "*.*" auf dem Sourcedrive, um einen eventuellen Disc changed-
  'Status vllig zu beseitigen und die Leseroutinen fr logische Sektoren
  'mit den ntigen Infos ber die Disk zu versorgen
  reg %ax,&h2f00
  call interrupt &h21:'Fgetdta
  olddtas%=reg(%es)
  olddtao%=reg(%bx)
  reg %ax,&h1a00
  reg %ds,(speicher&+256)\16
  reg %dx,(speicher&+256) and 15
  call interrupt &h21:'Fsetdta
  poke$ Speicher&, CHR$(Sourcedrv%+&h41)+":\*.*"+chr$(0)
  reg %ax,&h4e00
  reg %cx,0
  reg %ds,speicher&\16
  reg %dx,0
  call interrupt &h21:'Fsfirst
  reg %ax,&h1a00
  reg %ds,olddtas%
  reg %dx,olddtao%
  call interrupt &h21:'Fsetdta
  'Speicherbereiche festlegen
  MemBsec&=Speicher&+1024
  MemFat&=MemBsec&+BytesSector&
  MemCopy&=MemFat&:'Platz um am Ende 60KByte-weise Sektoren zu kopieren
  MemDir&=MemFat&+16*BytesSector&:'eine 12Bit-FAT kann nie so gro werden
  PRINT " Lese Bootsektor der Diskette"
  call HsReadabs(R&,MemBsec&,1,0,Sourcedrv%)
  'Bootsektor auswerten
  IF R&=0 THEN
   OBytesSector&= peeki(MemBsec&+&hB)
   OSecCluster&= PEEK(MemBsec&+&hD)
   OReservSec&= peeki(MemBsec&+&hE)
   ONumFats&= PEEK(MemBsec&+&h10)
   ODirEntr&= peeki(MemBsec&+&h11)
   OSecDisc&= clng(peeki(MemBsec&+&h13)) and 65535
   OSecFat&= peeki(MemBsec&+&h16)
   'Berechnungen daraus
   OSecDir&=(ODirEntr&*32+BytesSector&-1)\BytesSector&
   OCluDisc&=(OSecDisc&-OReservSec&-ONumFats&*OSecFat&-OSecDir&)\OSecCluster&
   'Prfungen auf Fehlermglichkeiten
   A%=-1
   IF OBytesSector&<>BytesSector& THEN PRINT " Fehler: Sektorgre nicht 512, sondern ";OBytesSector&;" Byte":A%=0
   IF (ONumFats&>2) OR (ONumFats&<1) THEN PRINT " Fehler:";ONumFats&;" File Allocation Tables":A%=0
   IF OReservSec&>1 THEN PRINT " Fehler: Mehr als ein reservierter Sektor":A%=0
   IF OCluDisc&>4078 THEN PRINT " Fehler: Mehr als 4078 Cluster, also 16 Bit FAT.":A%=0
   IF OSecDisc&<Esect&(Epromtyp%) THEN PRINT " Fehler: Die Disk ist zu klein fr den EPROM":A%=0
   IF A%<>0 THEN
    PRINT " Lese die FAT"
    call HsReadabs(R&,MemFat&,OSecFat&,1,Sourcedrv%)
    IF R&=0 THEN
     Startrsec&=OReservSec&+ONumFats&*OSecFat&
     PRINT " Lese das Rootdirectory"
     call HsReadabs(R&,MemDir&,OSecDir&,Startrsec&,Sourcedrv%)
     IF R&=0 THEN
      Startrsec&=Startrsec&+OSecDir&
      PRINT " Krze das Rootdirectory wenn mglich"
      SecDir&=OSecDir&
      R&=0
      WHILE (SecDir&>1) AND (R&=0)
       Ad&=MemDir&+SecDir&*BytesSector&
       FOR F&=1 TO BytesSector&
	R&=R& OR PEEK(Ad&-F&)
       NEXT F&
       IF R&=0 THEN SecDir&=SecDir&-1
      WEND
      'SecDir ist neue Directorylnge in Sektoren
      SecDisc&=Esect&(Epromtyp%)
      'berechne maximale Anzahl der Cluster (fr EPROM ohne FAT)
      CluDisc&=(SecDisc&-SecDir&-OReservSec&+OSecCluster&-1)\OSecCluster&
        'zhlt durch +OSecCluster-1 auch angebrochene Cluster mit
      'berechne FAT-Gre in Sektoren
      SecFat&=(((CluDisc&+2)*3+1)\2+BytesSector&-1)\BytesSector&
      'berechne endgltige Anzahl der Cluster (zhlt nur ganze Cluster)
      CluDisc&=(SecDisc&-SecDir&-OReservSec&-SecFat&)\OSecCluster&
      PRINT " Prfe, ob der Diskinhalt auch auf den EPROM pat"
      'durch Lesen des FAT-Bereiches, der frei sein mu
      R&=0
      FOR F&=2+CluDisc& TO OCluDisc&+1
       R&=R& OR FNFat12get&(MemFat&,F&)
      NEXT F&
      IF R&=0 THEN
       PRINT " Passe den Bootsektor an"
       PRINT "  Nur eine FAT"
       POKE MemBsec&+&h10,1
       DirEntr&=SecDir&*BytesSector&\32
       PRINT USING "######";DirEntr&;
       print " Pltze im Rootdirectory"
       pokei MemBsec&+&h11,DirEntr&
       A&=Ekapa&(Epromtyp%)*1024\BytesSector&
       PRINT USING "######";SecDisc&;
       print " logische Sektoren auf Medium"
       PRINT USING "######";A&;
       print " Sektoren auf Medium wird eingetragen. Sonst spinnt der PF"
       pokei MemBsec&+&h13,A&
       PRINT USING "######";SecFat&;
       print " Sektoren FAT"
       pokei MemBsec&+&h16,SecFat&
       PRINT "  8 Sektoren pro Spur und Seite, anderes erkennt der PF nicht"
       pokei MemBsec&+&h18,8
       PRINT "  2 Seiten, Standard auf PF"
       pokei MemBsec&+&h1A,2
       '
       PRINT " Erzeuge EPROM-Datei ";Epromdat$
       Poke$ Speicher&,Epromdat$+chr$(0)
       'Datei ffnen mit Fcreate
       reg %ax,&h3c00
       reg %cx,0
       reg %dx,0
       reg %ds,speicher&\16
       call interrupt &h21
       dh%=reg(%ax)
       IF (reg(%fl) and 1) = 0 THEN
	Fehler%=0
        PRINT "  Schreibe Bootsektor"
	call HsFwrite(Fehler%,Dh%,BytesSector&*OReservSec&,MemBsec&)
	IF Fehler%=0 THEN PRINT "  Schreibe FAT"
	call HsFwrite(Fehler%,Dh%,BytesSector&*SecFat&,MemFat&)
	IF Fehler%=0 THEN PRINT "  Schreibe Rootdirectory"
	call HsFwrite(Fehler%,Dh%,BytesSector&*SecDir&,MemDir&)
	IF Fehler%=0 THEN
         PRINT "  Kopiere die Datencluster von Disk in Datei"
	 Startwsec&=OReservSec&+SecFat&+SecDir&
	 F&=CluDisc&*OSecCluster&*BytesSector&
	 do
	  A&= MIN( MIN(60*1024,F&),(256-(Startwsec& AND 255))*BytesSector&)
	  S&=A&\BytesSector&
	  call HsReadabs(R&,MemCopy&,S&,Startrsec&,Sourcedrv%)
	  Fehler%=R&
	  IF Fehler%<>0 THEN PRINT " Sektorlesefehler"
	  call HsFwrite(Fehler%,Dh%,A&,MemCopy&)
	  F&=F&-A&
	  Startwsec&=Startwsec&+S&
	  Startrsec&=Startrsec&+S&
	  IF (F&<>0) AND ((Startwsec& AND 255)=0) THEN
	   'fllenden Sektor (Bootsektor) einfgen
	   Startwsec&=Startwsec&+1
	   call HsFwrite(Fehler%,Dh%,BytesSector&,MemBsec&)
	  END IF
	 loop until (F&=0) OR Fehler%
	 F&=Ekapa&(Epromtyp%)*1024\BytesSector&-Startwsec&
	 IF F&>0 THEN
          'flle EPROM-File auf, falls wegen > 1 Sektor/Cluster
          'am Ende noch Sektor(en) fehlen
	  call HsFwrite(Fehler%,Dh%,F&*BytesSector&,MemBsec&)
	 END IF
	END IF
	'Fclose
	reg %ax,&h3e00
	reg %bx,dh%
	call interrupt &h21
	IF Fehler% THEN
         PRINT " Beim Erzeugen der Datei trat ein Fehler auf."
         PRINT " Die Datei wird wieder gelscht."
	 'Fdelete
	 reg %ax,&h4100
	 reg %dx,0
	 reg %ds,speicher&\16
	 call interrupt &h21
        ELSE
         PRINT " EPROM-Datei wurde erstellt"
	END IF
       ELSE
        PRINT " Fehler beim Dateianlegen"
       END IF
      ELSE
       PRINT " Die Diskette ist zu voll und pat deshalb nicht in den EPROM"
      END IF
     ELSE
      PRINT " Fehler beim Lesen des Rootdirectory"
     END IF
    ELSE
     PRINT " Fehler beim Lesen der FAT"
    END IF
   END IF
  ELSE
   PRINT " Fehler beim Lesen des Bootsektors"
  END IF
 END IF
 'Speicher ist im Basic, also nicht freigeben
 PRINT
 PRINT " EPROM-Konverter wird beendet. Weiter mit [Leertaste]"
 A%=FNTastwahl%(" ")
 END :'Programmende
 '
 '
 Epromdaten:
 'Bezeichnung, Kapazitt in KByte, Auswahlzeichen,
 'reale Anzahl 512Byte-Sektoren
 DATA "27C512",64,"5",128
 DATA "27C010=27C1001",128,"1",256
 DATA "27C020=27C2001",256,"2",511
 DATA "27C040=27C4001",512,"4",1021
 DATA "27C080=27C8001",1024,"8",2041
 '
 '
 '
 DEF FNTastwahl%(A$)
 'wartet auf Eingabe eines im bergebenen String A$
 'enthaltenen Zeichens, liefert dann die Position
 'in A$ (1 fr erstes Zeichen)
  LOCAL A%, b$
  do
   do
    do
     b$ = inkey$
    loop until b$<>""
    a% = asc(b$)
   loop until a% > 0
   a% = instr(ucase$(a$), ucase$(b$))
  loop until a% > 0
  FNTastwahl% = a%
 end def
 '
 DEF FNFat12get&(Ad&,Clu&)
 'holt den FAT-Eintrag der auf dem Platz des Clusters Clu steht
 'die FAT liegt dazu ab Adresse Ad im Speicher
  LOCAL D&,e&
  e&=Ad&+(Clu& \ 2)*3
  IF (Clu& AND 1)=0 THEN
   D&= PEEK(e&) OR (( PEEK(e&+1) AND 15) * 256)
  ELSE
   D&=( PEEK(e&+2) * 16) OR ( PEEK(e&+1) \ 4)
  END IF
  FNFat12get& = d&
 end def
 '
 sub HsReadabs(Fehler&,Ad&,Anz&,Beg&,Drv%)
 'liest Anz logische Sektoren ab Nummer Beg in den Speicher ab Ad
 'vom Laufwerk Drv (0=A:)
 'Wenn fr die Parameter einzelne Variablen bergeben werden, erfolgt
 'die bergabe automatisch als Referenz. Also Original wird auch modifiziert.
 'Bei Ausdrcken oder einfachen var. in () erfolgt bergabe als Wert.
  'durch den folgenden Aufruf anstelle eines direkten Aufrufes ohne
  'den Umweg ber HsReadabs werden die Parametertypen auch immer konvertiert
  call urrabs(Fehler&,Ad&,Anz&,Beg&,Drv%)
 end sub
 '
 sub urrabs inline
  'den Maschinenteil einfgen
  $inline &h55,&h89,&hE5,&h1E,&h57,&h56,&hB1,&h04
  $inline &hC4,&h7E,&h12,&h26,&h8A,&h45,&h02,&hD2
  $inline &hE0,&h26,&h8B,&h1D,&h89,&hDA,&hD3,&hEA
  $inline &h08,&hC6,&h8E,&hDA,&h83,&hE3,&h0F,&hC4
  $inline &h7E,&h06,&h26,&h8B,&h05,&hC4,&h7E,&h0A
  $inline &h26,&h8B,&h15,&hC4,&h7E,&h0E,&h26,&h8B
  $inline &h0D,&h55,&hCD,&h25,&h72,&h02,&h2B,&hC0
  $inline &h9D,&h5D,&hC4,&h7E,&h16,&h26,&h89,&h05
  $inline &h26,&hC7,&h45,&h02,&h00,&h00,&h5E,&h5F
  $inline &h1F,&h5D
  'Das ist folgendes Assemblerprogramm:
  ' push bp
  ' mov bp,sp
  ' push ds
  ' push di
  ' push si
  ' mov cl,4           ;fr 4* schieben
  ' les di,[bp+012h]   ;Zeiger auf Ad&
  ' es: mov al,[di+2]  ;Lowbyte vom Highword
  ' shl al,cl          ;Bit 3-0 als Bit 15-12 des Segments
  ' es: mov bx,[di]    ;Lowword
  ' mov dx,bx
  ' shr dx,cl          ;Bit 15-4 als Bit 11-0 des Segments
  ' or dh,al
  ' mov ds,dx
  ' and bx, 0fh        ;Bit 3-0 bleiben fr Offset
  ' les di,[bp+6]      ;Zeiger auf Drv%
  ' es: mov ax,[di]
  ' les di,[bp+0ah]    ;Zeiger auf Beg&
  ' es: mov dx,[di]
  ' les di,[bp+0eh]    ;Zeiger auf Anz&
  ' es: mov cx,[di]
  '
  ' push bp
  ' int 025h           ;Absolutes Lesen ber DOS
  ' jc m1              ;Fehler!
  ' sub ax,ax          ;kein Fehler, also 0 zurck
  'm1:
  ' popf               ;mein altes Flagregister
  ' pop bp             ;wurde sicherheitshalber gesichert
  '
  ' les di,[bp+016h]   ;Zeiger auf Fehler&
  ' es: mov [di],ax
  ' es: mov w[di+2],0
  ' pop si
  ' pop di
  ' pop ds
  ' pop bp
  '
  ';Ende, ohne RETF oder so, da es INLINE wird
 end sub
 '
 sub HsFwrite(Fehler%,H%,B&,A&)
 'schreibt nur B Bytes ab Adresse A in das File H, wenn Fehler = 0 ist
 'B darf maximal 65535 sein wegen DOS
 'gibt in Fehler den Status zurck:
 ' negativ fr TOS-Fehler
 ' 0 fr ok
 ' 1 fr Disk voll
  IF Fehler%=0 THEN
   'Fwrite
   reg %ax,&h4000
   reg %bx,h%
   reg %cx,b&
   reg %dx,a& and 15
   reg %ds,a&\16
   call interrupt &h21
   if (reg(%fl) and 1)=0 then
    fehler%=((clng(reg(%ax)) and 65535)<>b&) and 1
   else
    fehler%=-reg(%ax)
   end if
  END IF
 end sub
 '
 '
